// Generated from host-config.json. Do not edit!
#ifndef HOST_CONFIG_SCHEMA_H
#define HOST_CONFIG_SCHEMA_H

#include <sys/types.h>
#include <stdint.h>
#include "json_common.h"
#include "defs.h"
#include "mount_spec.h"
#include "bind_options.h"
#include "volume_options.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
    char *name;

    int maximum_retry_count;

    yajl_val _residual;
}
host_config_restart_policy;

void free_host_config_restart_policy(host_config_restart_policy *ptr);

host_config_restart_policy *make_host_config_restart_policy(yajl_val tree, const struct parser_context *ctx, parser_error *err);

yajl_gen_status gen_host_config_restart_policy(yajl_gen g, const host_config_restart_policy *ptr, const struct parser_context *ctx, parser_error *err);

typedef struct {
    char *cgroup_permissions;
    char *path_in_container;
    char *path_on_host;
}
host_config_devices_element;

void free_host_config_devices_element(host_config_devices_element *ptr);

host_config_devices_element *make_host_config_devices_element(yajl_val tree, const struct parser_context *ctx, parser_error *err);

typedef struct {
    char *name;
    int64_t hard;
    int64_t soft;
}
host_config_ulimits_element;

void free_host_config_ulimits_element(host_config_ulimits_element *ptr);

host_config_ulimits_element *make_host_config_ulimits_element(yajl_val tree, const struct parser_context *ctx, parser_error *err);

typedef struct {
    char *page_size;
    uint64_t limit;
}
host_config_hugetlbs_element;

void free_host_config_hugetlbs_element(host_config_hugetlbs_element *ptr);

host_config_hugetlbs_element *make_host_config_hugetlbs_element(yajl_val tree, const struct parser_context *ctx, parser_error *err);

typedef struct {
    char *path_on_host;

    char *path_in_container;

    char *permissions;

    uint64_t size;

    yajl_val _residual;
}
host_config_host_channel;

void free_host_config_host_channel(host_config_host_channel *ptr);

host_config_host_channel *make_host_config_host_channel(yajl_val tree, const struct parser_context *ctx, parser_error *err);

yajl_gen_status gen_host_config_host_channel(yajl_gen g, const host_config_host_channel *ptr, const struct parser_context *ctx, parser_error *err);

typedef struct {
    char **volumes_from;
    size_t volumes_from_len;

    char **binds;
    size_t binds_len;

    mount_spec **mounts;
    size_t mounts_len;

    char *network_mode;

    char **group_add;
    size_t group_add_len;

    char *ipc_mode;

    char *pid_mode;

    bool privileged;

    bool system_container;

    char **ns_change_files;
    size_t ns_change_files_len;

    char *user_remap;

    int64_t shm_size;

    bool auto_remove;

    bool auto_remove_bak;

    bool readonly_rootfs;

    char *uts_mode;

    char *userns_mode;

    json_map_string_string *sysctls;

    char *runtime;

    host_config_restart_policy *restart_policy;

    char **cap_add;
    size_t cap_add_len;

    char **cap_drop;
    size_t cap_drop_len;

    char **dns;
    size_t dns_len;

    char **dns_options;
    size_t dns_options_len;

    char **dns_search;
    size_t dns_search_len;

    char **extra_hosts;
    size_t extra_hosts_len;

    char *hook_spec;

    int64_t cpu_shares;

    int64_t memory;

    int oom_score_adj;

    uint16_t blkio_weight;

    defs_blkio_weight_device **blkio_weight_device;
    size_t blkio_weight_device_len;

    defs_blkio_device **blkio_device_read_bps;
    size_t blkio_device_read_bps_len;

    defs_blkio_device **blkio_device_write_bps;
    size_t blkio_device_write_bps_len;

    defs_blkio_device **blkio_device_read_iops;
    size_t blkio_device_read_iops_len;

    defs_blkio_device **blkio_device_write_iops;
    size_t blkio_device_write_iops_len;

    int64_t nano_cpus;

    int64_t cpu_period;

    int64_t cpu_quota;

    int64_t cpu_realtime_period;

    int64_t cpu_realtime_runtime;

    char *cpuset_cpus;

    char *cpuset_mems;

    host_config_devices_element **devices;
    size_t devices_len;

    char **device_cgroup_rules;
    size_t device_cgroup_rules_len;

    char **security_opt;
    size_t security_opt_len;

    json_map_string_string *storage_opt;

    int64_t kernel_memory;

    int64_t memory_reservation;

    int64_t memory_swap;

    uint64_t *memory_swappiness;

    bool oom_kill_disable;

    int64_t pids_limit;

    int64_t files_limit;

    host_config_ulimits_element **ulimits;
    size_t ulimits_len;

    host_config_hugetlbs_element **hugetlbs;
    size_t hugetlbs_len;

    host_config_host_channel *host_channel;

    char *env_target_file;

    char *external_rootfs;

    char *cgroup_parent;

    yajl_val _residual;
}
host_config;

void free_host_config(host_config *ptr);

host_config *make_host_config(yajl_val tree, const struct parser_context *ctx, parser_error *err);

yajl_gen_status gen_host_config(yajl_gen g, const host_config *ptr, const struct parser_context *ctx, parser_error *err);

host_config *host_config_parse_file(const char *filename, const struct parser_context *ctx, parser_error *err);

host_config *host_config_parse_file_stream(FILE *stream, const struct parser_context *ctx, parser_error *err);

host_config *host_config_parse_data(const char *jsondata, const struct parser_context *ctx, parser_error *err);

char *host_config_generate_json(const host_config *ptr, const struct parser_context *ctx, parser_error *err);

#ifdef __cplusplus
}
#endif

#endif

